#define X first
#define Y second
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vpii = vector<pii>;
const int INF = 1e9;
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    for (; t--;) {
        int n; cin >> n;
        vpii r, b;
        for (int i = 0; i < n; ++i) {
            pii p; char c;
            cin >> p.X >> p.Y >> c;
            (c == 'R' ? r : b).push_back(p);
        }
        sort(r.rbegin(), r.rend()); sort(b.rbegin(), b.rend());
        int ri = 0, bi = 0;
        bool bd = false, rd = false;
        ll s = 0;
        int i = 0;
        while (ri < r.size() && bi < b.size()) {
            ll c = min(r[ri].Y, b[bi].Y);
            s += c * (r[ri].X - b[bi].X);
            if (s <= -2) bd = true; 
            if (s >= 1 && i < 199998) rd = true;
            if ((r[ri].Y -= c) == 0) ++ri;
            if ((b[bi].Y -= c) == 0) ++bi;
            ++i;
        }
        if (ri == r.size())
            if (bi == b.size())
                cout << "Draw " << r.front().first << " +\n";
            else
                if (rd)
                    cout << "Draw " << r.front().first << " +\n";
                else
                    cout << "Second\n";
        else
            if (bd)
                cout << "Draw " << r.front().first << " +\n";
            else
                cout << "First " << r.front().first << " +\n";
    }
}
